其他分享
首页 > 其他分享> > Leetcode摆动序列系列

Leetcode摆动序列系列

作者:互联网

摆动序列系列

Leetcode280 摆动排序

题目:给你一个的整数数组 nums, 将该数组重新排序后使 nums[0] <= nums[1] >= nums[2] <= nums[3]...

题解:设置双指针在排好序的一头一尾,这样先选取小的再选取大的,循环直至数组中的数都被选完。

Java
class Solution {
    public void wiggleSort(int[] nums) {
        int length= nums.length;
        // 复制nums数组用于排序
        int[] temp = Arrays.copyOf(nums, length);
        Arrays.sort(temp);
        int left = 0;
        int right = length - 1;
        int flag = 1;
        int i = 0;
        while (i < length) {
            if (flag == 1) {
                nums[i] = temp[left];
                left++;
            } else {
                nums[i] = temp[right];
                right--;
            }
            i++;
            flag *= -1;
        }
    }
}

Leetcode376 摆动序列

题目:如果连续数字之间的差严格地在正数和负数之间交替,则数字序列称为摆动序列。
例如, [1, 7, 4, 9, 2, 5] 是一个 摆动序列 ,因为差值 (6, -3, 5, -7, 3) 是正负交替出现的。
相反,[1, 4, 7, 2, 5] 和 [1, 7, 4, 5, 5] 不是摆动序列,第一个序列是因为它的前两个差值都是正数,第二个序列是因为它的最后一个差值为零。
子序列 可以通过从原始序列中删除一些(也可以不删除)元素来获得,剩下的元素保持其原始顺序。
给你一个整数数组 nums ,返回 nums 中作为 摆动序列 的 最长子序列的长度 。

题解:设置两个变量,一个存放以升序为结尾的数组长度up,另一个存放以降序为结尾的数组长度down
当前数字比前一个数字大,则需要前面是一个以降序为结尾的数组,即 up = down + 1
当前数字比前一个数字小,则需要前面是一个以升序为结尾的数组,即 down = up + 1

Java
class Solution {
    public int wiggleMaxLength(int[] nums) {
        int n = nums.length;
        if (n == 0 || n == 1) {
            return n;
        }
        int up = 1;
        int down = 1;
        for (int i = 1; i < n; i++) {
            if (nums[i] > nums[i - 1]) {
                up = down + 1;
            } else if (nums[i] < nums[i - 1]) {
                down = up + 1;
            }
        }
        return Math.max(down, up);
    }
}

Leetcode324 摆动排序Ⅱ

题目:给你一个整数数组 nums,将它重新排列成 nums[0] < nums[1] > nums[2] < nums[3]... 的顺序。

题解:本题与摆动排序Ⅰ不同,有严格的大小关系,不能相等。所以不能像第一题那样将双指针设置在一头一尾,这样不能保证后边不出现前后相等的情况。所以本题将双指针设置在排好序的数组的中间和末尾位置,均向前移动。

Java
class Solution {
    public void wiggleSort(int[] nums) {
        int length = nums.length;
        int[] temp = Arrays.copyOf(nums, length);
        Arrays.sort(temp);
        int left = (length - 1) / 2;
        int right = length - 1;
        int flag = 1;
        int i = 0;
        while (i < length) {
            if (flag == 1) {
                nums[i] = temp[left];
                left--;
            } else {
                nums[i] = temp[right];
                right--;
            }
            i++;
            flag *= -1;
        }
    }
}

标签:temp,nums,int,序列,length,数组,摆动,Leetcode
来源: https://www.cnblogs.com/waitting975/p/16418185.html